=== modified file 'loggerhead/static/javascript/custom.js'
--- loggerhead/static/javascript/custom.js	2008-06-25 23:35:52 +0000
+++ loggerhead/static/javascript/custom.js	2008-06-26 22:59:24 +0000
@@ -134,15 +134,31 @@
     $$('.revision_log').each(function(item, i)
     {
     	var colapsable = item.colapsable;
-        var expander = item.getElement('.revisioninfo').get('slide');
-        var shortDescription = item.getElement( '.short_description' );
-        var longDescription = item.getElement( '.long_description' );
         if(action == 'close')
         {
             $('expand_all').setStyle('display','block');
             $('collapse_all').setStyle('display','none');
             colapsable.close();
+        }
+        else if(action == 'open')
+        {
+            $('expand_all').setStyle('display','none');
+            $('collapse_all').setStyle('display','block');
+            colapsable.open();
+        }
+    });
+}
 
+function toggle_expand_all_revisionview(action)
+{
+    $$('.diffBox').each(function(item, i)
+    {
+    	var colapsable = item.colapsable;
+        if(action == 'close')
+        {
+            $('expand_all').setStyle('display','block');
+            $('collapse_all').setStyle('display','none');
+            colapsable.close();
         }
         else if(action == 'open')
         {

=== modified file 'loggerhead/templates/revision.pt'
--- loggerhead/templates/revision.pt	2008-06-25 20:20:02 +0000
+++ loggerhead/templates/revision.pt	2008-06-26 22:59:24 +0000
@@ -54,11 +54,16 @@
         </tal:we-are-comparing>
         
         <tal:revision-info replace="structure python:revisioninfo(url, branch, change, modified_file_link_rev)" />
-        <!-- FIXME: This doesn't work yet -->
-        <p class="expand"><a href="#"><img tal:attributes="src python:branch.static_url('/static/images/treeCollapsed.png')" 
-                             alt="collapse all" /> collapse all</a></p>
-                        <p class="codin"><img tal:attributes="src python:branch.static_url('/static/images/newCode.gif')" 
-                           alt="added" /> added</p>
+        <p class="expand" id="expand_all" style="display:none;"><a tal:attributes="href string:javascript:toggle_expand_all_revisionview('open')">
+            <img tal:attributes="src python:branch.static_url('/static/images/treeCollapsed.png')"
+                  alt="expand all" /> expand all</a>
+        </p>
+        <p class="expand" id="collapse_all"><a tal:attributes="href string:javascript:toggle_expand_all_revisionview('close')">
+            <img tal:attributes="src python:branch.static_url('/static/images/treeExpanded.png')"
+                  alt="collapse all" /> collapse all</a>
+        </p>
+        <!-- Table -->        
+        <p class="codin"><img tal:attributes="src python:branch.static_url('/static/images/newCode.gif')" alt="added" /> added</p>
         <p class="codin"><img tal:attributes="src python:branch.static_url('/static/images/deleteCode.gif')" alt="removed" /> removed</p>
         <div class="clear"><!-- --></div>
 
@@ -72,9 +77,9 @@
           <tal:block repeat="item change/changes/modified">
 
               <tal:u define="u python:util.uniq(uniqs, item.file_id)">
-                      <div class="diffBox"><img tal:attributes="src python:branch.static_url('/static/images/treeCollapsed.png');
-                                                                title python:branch.static_url('/static/images/treeExpanded.png');
-                                                                alt python:branch.static_url('/static/images/treeCollapsed.png')"
+                      <div class="diffBox"><img tal:attributes="src python:branch.static_url('/static/images/treeExpanded.png');
+                                                                title python:branch.static_url('/static/images/treeCollapsed.png');
+                                                                alt python:branch.static_url('/static/images/treeExpanded.png')"
                                                                 class="expand_diff" />
                                            <a tal:attributes="href python:url(['/annotate', change.revno], clear=1, file_id=item.file_id);
                                                               id string:${item/filename}-s;

